<template>
  <label :class="[$style.formCheckbox, hasSlot ? $style.formCheckboxSlot : null]">
    <slot></slot>
    <input
      :class="$style.formCheckboxField"
      type="checkbox"
      :checked="checked"
      @input="handleInput"
    />
    <span :class="$style.formCheckboxCheckmark"></span>
  </label>
</template>

<script>
export default {
  name: "MeFormCheckbox",
  model: {
    prop: "value",
    event: "input",
  },
  props: {
    value: {
      type: Boolean,
      default: false,
      required: true,
    },
  },
  methods: {
    handleInput(ev) {
      this.$emit("input", !this.value);
    },
  },
  computed: {
    checked() {
      return this.value;
    },
    hasSlot () {
      return this.$slots["default"];
    }
  }
};
</script>

<style lang="scss" module>
.formCheckbox {
  display: inline-block;
  position: relative;
  margin-top: 0.25rem;
  margin-bottom: 0.25rem;
  // margin-left: 0.25rem;
  height: 1.5rem;
  min-width: 1.5rem;
  font-size: 1rem;
  cursor: pointer;
  user-select: none;

  // When have a slot text
  &Slot {
    padding-left: 2rem;
  }

  /* Hide the browser's default checkbox */
  & > .formCheckboxField {
    position: absolute;
    opacity: 0;
    cursor: pointer;
    height: 0;
    width: 0;
  }

  /* Create a custom checkbox */
  & > .formCheckboxCheckmark {
    position: absolute;
    top: 0;
    left: 0;
    height: 1.5rem;
    width: 1.5rem;
    background-color: #cccccc;
    border-radius: 3px;
  }

  /* On mouse-over, add a background color */
  &:hover > .formCheckboxField ~ .formCheckboxCheckmark {
    background-color: #cccccc;
  }

  /* When the checkbox is checked, add a background */
  & > .formCheckboxField:checked ~ .formCheckboxCheckmark {
    background-color: #cccccc;
  }

  /* When the focus on checkbox, add a shadow for simulate focus */
  & > .formCheckboxField:focus ~ .formCheckboxCheckmark {
    box-shadow: 0 0 0 3px rgba($color-gray-web, 0.75);
  }

  /* Create the checkmark/indicator (hidden when not checked) */
  .formCheckboxCheckmark:after {
    content: "";
    position: absolute;
    display: none;
  }

  /* Show the checkmark when checked */
  & > .formCheckboxField:checked ~ .formCheckboxCheckmark:after {
    display: block;
  }

  /* Style the checkmark/indicator */
  & > .formCheckboxCheckmark:after {
    left: 9px;
    top: 5px;
    width: 0.35rem;
    height: 0.75rem;
    border: solid black;
    border-width: 0 2px 2px 0;
    transform: rotate(45deg);
  }
}
</style>